<%-- $Id:manual_scan.jsp 4187 2008-03-20 11:15:25Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.plugin.About"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
 	import="net.sf.basedb.util.extensions.ExtensionPoint"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.util.extensions.ExtendedAbout"
 	import="net.sf.basedb.util.extensions.manager.ExtensionsManager"
 	import="net.sf.basedb.util.extensions.manager.ExtensionsFile"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.UnsafeScriptable"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.servlet.ContentSecurityPolicyFilter"
	import="java.util.List"
	import="java.util.Comparator"
	import="java.util.Collections"
	import="java.util.Date"
	import="java.io.File"
	import="java.io.FileNotFoundException"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
DbControl dc = null;
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateTimeFormatter(sc);
	
	dc = sc.newDbControl(":Extensions installation wizard");
	ExtensionsControl ec = ExtensionsControl.get(dc);
	ec.checkPermission(Permission.WRITE);
	ec.scanForChanges();
	List<ExtensionsFile> xtFiles = ec.getFiles();
	
	// Re-order extensions
	Collections.sort(xtFiles, 
		new Comparator<ExtensionsFile>()
		{
			public int compare(ExtensionsFile f1, ExtensionsFile f2)
			{
				// Sort new or modified extensions first...
				boolean p1 = f1.isNew() || f1.wasModified();
				boolean p2 = f2.isNew() || f2.wasModified();
				if (p1 != p2) return p1 ? -1 : 1;
				
				// ...then deleted and invalid extensions...
				p1 = f1.hasError() || !f1.exists() || !f1.isValid();
				p2 = f2.hasError() || !f2.exists() || !f2.isValid();
				if (p1 != p2) return p1 ? -1 : 1;
				
				// ...and finally all other extensions
				return f1.getName().compareTo(f2.getName());
			}
		});
	
	List<File> ignoredFiles = ec.getIgnoredFiles();
	%>
	<base:page type="popup" title="Extensions and plug-ins installation wizard">
	<base:head scripts="table.js,~wizard.js" styles="table.css">
	<style>
		#ignored-header td
		{
			font-weight: bold;
			border-top-style: solid;
			border-bottom-style: solid;
			border-top-width: 1px;
			border-bottom-width: 1px;
			border-top-color: inherit;
			border-bottom-color: inherit;
			padding: 1px 2px;
		}
		.ignored-file td
		{
			color: #666666;
		}
	</style>
	</base:head>
	<base:body>
	<h1>Extensions and plug-ins installation wizard <base:help helpid="extensions.install-wizard" /></h1>
	<div class="content">
	<tbl:table id="scan" subclass="fulltable" stickyheaders="<%=null%>" action="index.jsp" >
		<tbl:columndef id="file" title="File" />
		<tbl:columndef id="status" title="Status" style="text-align: center;"/>
		<tbl:columndef id="install" title="Install" style="text-align: center;"/>
		<tbl:columndef id="uninstall" title="Uninstall" style="text-align: center;"/>
		<tbl:columndef id="ignore" title="Ignore" style="text-align: center;" />
		<tbl:columndef id="about" title="About" />
	
		<tbl:data style="top: 0px; margin-top: 0px;">
			<tbl:headers>
				<tbl:headerrow>
					<tbl:columnheaders />
				</tbl:headerrow>
			</tbl:headers>
			<tbl:rows>
			<%
			for (ExtensionsFile xtFile : xtFiles)
			{
				if (xtFile.getFile() == null) continue; // We skip internal extensions/plug-ins files
				List<Extension<?>> unsafeExtensions = ec.checkUnsafeScriptableUsage(xtFile);
				
				About about = xtFile.getAbout();
				ExtendedAbout xtAbout = about instanceof ExtendedAbout ? (ExtendedAbout)about : null;
				Throwable error = null;
				String name = xtFile.getName();
				String status = "";
				String icon = "";
				boolean allowInstall = false;
				boolean allowUninstall = false;
				boolean allowIgnore = false;
				boolean checkInstall = false;
				boolean checkUninstall = false;
				boolean checkIgnore = false;
				if (!xtFile.exists())
				{
					status = "Deleted";
					allowUninstall = true;
					checkUninstall = true;
					error = new FileNotFoundException(xtFile.getFile() + " doesn't exist or is not readable.");
				}
				else if (!xtFile.isValid())
				{
					status = "Invalid";
					error = xtFile.getValidationError();
					if (xtFile.isInstalled())
					{
						allowUninstall = true;
						checkUninstall = true;
					}
					allowIgnore = true;
					checkIgnore = true;
				}
				else if (xtFile.isNew())
				{
					status = "New";
					allowInstall = true;
					allowIgnore = true;
					checkInstall = true;
				}
				else if (xtFile.wasModified())
				{
					status = "Modified";
					allowInstall = true;
					allowUninstall = true;
					allowIgnore = true;
					checkInstall = true;
				}
				else if (xtFile.hasError())
				{
					status = "Error";
					allowInstall = true;
					allowUninstall = true;
					allowIgnore = true;
				}
				else
				{
					status = "Already installed";
					allowInstall = true;
					allowUninstall = true;
					allowIgnore = true;
				}
				%>
				<tbl:row>
					<tbl:cell column="file" style="white-space: nowrap;"><%=name%></tbl:cell>
					<tbl:cell column="status" style="text-align: center;"><%=status%></tbl:cell>
					<tbl:cell column="install" style="text-align: center;">
						<%
						if (allowInstall)
						{
							%>
							<input type="checkbox" class="auto-init" data-auto-init="install" 
								name="<%=name%>.install" value="1" <%=checkInstall ? "checked" : "" %>
								>
							<%
						}
						%>
					</tbl:cell>
					<tbl:cell column="uninstall" style="text-align: center;">
						<%
						if (allowUninstall)
						{
							%>
							<input type="checkbox" class="auto-init" data-auto-init="uninstall"
								name="<%=name%>.uninstall" value="1" <%=checkUninstall ? "checked" : "" %>
								>
							<%
						}
						%>
					</tbl:cell>
					<tbl:cell column="ignore" style="text-align: center;">
						<%
						if (allowIgnore)
						{
							%>
							<input type="checkbox" class="auto-init" data-auto-init="ignore"
								name="<%=name%>.ignore" value="1" <%=checkIgnore ? "checked" : "" %>
								>
							<%
						}
						%>
					</tbl:cell>
					<tbl:cell column="about">
						<%
						if (about != null)
						{
							%>
							<b><%=HTML.encodeTags(about.getName())%></b> <%=about.getVersion() == null ? "" : "(v" + about.getVersion() + ")"%><br>
							<%=HTML.encodeTags(about.getDescription())%><br>
							<%=HTML.niceFormat(about.getUrl())%>
							<%
						}
						if (unsafeExtensions.size() > 0)
						{
							%>
							<div class="messagecontainer note">
								<base:icon image="warning.png" />
								This plug-in contain <%=unsafeExtensions.size()%> extension(s) that 
								may violate the <b>Content Security Policy</b> setting on this server.
								See BASE documentation for more information.
							</div>
							<%
						}
						if (error != null)
						{
							%>
							<div class="messagecontainer error">
							<%=error.getClass().getSimpleName()%>: <%=HTML.encodeTags(error.getMessage())%>
							</div>
							<%
						}
						%>
					</tbl:cell>
					
				</tbl:row>
				<%
			}
			if (ignoredFiles.size() > 0)
			{
				%>
				<tr id="ignored-header" class="ignored-header bg-filled-100">
					<td colspan="2">Ignored files (<%=ignoredFiles.size() %>)</td>
					<td class="cell" style="text-align: center;">Install</td>
					<td class="cell" ></td>
					<td  class="cell" style="text-align: center;">Stop ignoring</td>
					<td class="cell"></td>
				</tr>
				<tbody class="rows">
				<%
				for (File ignoredFile : ignoredFiles)
				{
					String name = ignoredFile.getName();
					String fileInfo = "";
					boolean checkStopIgnore = false;
					boolean allowInstall = true;
					if (ignoredFile.isFile())
					{
						fileInfo = Values.formatBytes(ignoredFile.length());
						fileInfo += "; " + dateFormatter.format(new Date(ignoredFile.lastModified()));
					}
					else
					{
						fileInfo = "File does not exist.";
						checkStopIgnore = true;
						allowInstall = false;
					}
					%>
					<tbl:row subclass="ignored-file">
						<tbl:cell column="file" style="white-space: nowrap;"><%=name%></tbl:cell>
						<tbl:cell column="status" style="text-align: center;">Ignored</tbl:cell>
						<tbl:cell  column="install" style="text-align: center;">
							<%
							if (allowInstall)
							{
								%>
								<input type="checkbox" class="auto-init" data-auto-init="install" 
									name="<%=name%>.install" value="1">
								<%
							}
							%>
						</tbl:cell>
						<tbl:cell subclass="cell input" column="ignore" style="text-align: center;">
							<input type="checkbox" class="auto-init" data-auto-init="stop-ignore"
								name="<%=name%>.stopignore" value="1" <%=checkStopIgnore ? "checked" : "" %>>
						</tbl:cell>
						<tbl:cell column="about"><%=HTML.encodeTags(fileInfo) %></tbl:cell>
					</tbl:row>
					<%
				}
				%>
				</tbody>
				<%
			}
			%>
			</tbl:rows>
		</tbl:data>
	</tbl:table>
	</div>

	<base:buttongroup subclass="dialogbuttons">
		<base:button id="startScan" title="Next" />
		<base:button id="close" title="Cancel" />
	</base:buttongroup>
	
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
