<%-- $Id: edit_extract.jsp 7954 2021-05-12 13:27:22Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Sample"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Tag"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.Kit"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.ListUtil"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"	
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.tabcontrol.TabAction"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.json.JsonUtil"
	import="net.sf.basedb.util.json.JsonConverter"
	import="net.sf.basedb.util.json.NameableConverter"
	import="org.json.simple.JSONObject"
	import="org.json.simple.JSONArray"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.EXTRACT;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl(":Edit "+itemType);
try
{
	String title = null;
	Extract extract = null;
	BioMaterialEvent creationEvent = null;
	Date eventDate = null;
	Item parentType = null;
	boolean lockEventProperties = false;
	
	WellCoordinateFormatter rowFormatter = new WellCoordinateFormatter(true);
	WellCoordinateFormatter columnFormatter = new WellCoordinateFormatter(false);

	boolean readCurrentSubtype = true;
	ItemSubtype currentSubtype = null;
	boolean readCurrentProtocol = true;
	Protocol currentProtocol = null;
	boolean readCurrentKit = true;
	Kit currentKit = null;
	boolean readCurrentTag = true;
	Tag currentTag = null;
	boolean readCurrentSample = true;
	Sample currentSample = null;
	Float usedFromSample = null;
	String name = null;
	ItemQuery<Extract> extractsQuery = null;
	boolean readCurrentBioWell = true;
	BioWell currentBioWell = null;	
	boolean lockedWell = false;
	boolean readCurrentBioPlate = true;
	BioPlate currentBioPlate = null;
	
	if (itemId == 0)
	{
		title = "Create extract";
		cc.removeObject("item");
		if (cc.getPropertyFilter("creationEvent.protocol.name") != null)
		{
			currentProtocol = Base.getFirstMatching(dc, Protocol.getQuery(), "name", cc.getPropertyFilter("creationEvent.protocol.name"));
		}
		if (cc.getPropertyFilter("creationEvent.kit.name") != null)
		{
			currentKit = Base.getFirstMatching(dc, Kit.getQuery(), "name", cc.getPropertyFilter("creationEvent.kit.name"));
		}
		if (cc.getPropertyFilter("tag.name") != null)
		{
			currentTag = Base.getFirstMatching(dc, Tag.getQuery(), "name", cc.getPropertyFilter("tag.name"));
		}
		int currentSubtypeId = Values.getInt(request.getParameter("subtype_id"));
		List<ItemSubtype> relatedToParent = Collections.emptyList();
		int sampleId = Values.getInt(request.getParameter("sample_id"));
		int extractId = Values.getInt(request.getParameter("extract_id"));

		if (sampleId != 0)
		{
			currentSample  = Sample.getById(dc, sampleId);
			parentType = Item.SAMPLE;
			name = currentSample.getName() + ".e" + (currentSample.countExtracts() + 1);			
			if (currentSubtypeId == 0)
			{
				relatedToParent = ItemSubtype.getParentSubtypes(dc, currentSample, Item.EXTRACT);
			}
		}
		else if (extractId != 0)
		{
			parentType = Item.EXTRACT;
			Extract e = Extract.getById(dc, extractId);
			name = e.getName() + ".e" + (e.countExtracts()+1);
			extractsQuery = Extract.getQuery();
			extractsQuery.restrict(Restrictions.eq(Hql.property("id"), Expressions.integer(extractId)));
			if (currentSubtypeId == 0)
			{
				relatedToParent = ItemSubtype.getParentSubtypes(dc, e, Item.EXTRACT);
			}
		}
		else if (Values.getBoolean(request.getParameter("pooled")))
		{
			parentType = Item.EXTRACT;
			name = Values.getString(cc.getPropertyValue("name"), "New pooled extract");
			extractsQuery = Extract.getQuery();
			extractsQuery.restrict(Restrictions.in(Hql.property("id"), Expressions.parameter("selected")));
			extractsQuery.setParameter("selected", cc.getSelected(), Type.INT);
		}
		else
		{
			name = Values.getString(cc.getPropertyValue("name"), "New extract");
		}
		if (currentSubtypeId == 0) 
		{
			if (relatedToParent.size() > 0)
			{
				// Find most recently used related subtype
				List<ItemSubtype> recentSubtypes = cc.getRecent(dc, Item.ITEMSUBTYPE);
				currentSubtype = ListUtil.findFirstCommon(recentSubtypes, relatedToParent, relatedToParent.get(0));
			}
			else
			{
				int recentSubtypeId = Values.getInt(cc.getRecent(Item.ITEMSUBTYPE.name(), 0));
				currentSubtypeId = Values.getInt(cc.getPropertyValue("itemSubtype"), recentSubtypeId);
				if (currentSubtypeId > 0) currentSubtype = ItemSubtype.getById(dc, currentSubtypeId);
			}
		}
		eventDate = cc.getPropertyObject("creationEvent.eventDate");		
	}
	else
	{
		extract = Extract.getById(dc, itemId);
		extract.checkPermission(Permission.WRITE);
		parentType = extract.getParentType();
		cc.setObject("item", extract);
		title = "Edit extract -- " + HTML.encodeTags(extract.getName());
	
		creationEvent = extract.getCreationEvent();
		eventDate = creationEvent.getEventDate();
		name = extract.getName();
		lockEventProperties = !creationEvent.hasPermission(Permission.WRITE);
		
		try
		{
			currentSubtype = extract.getItemSubtype();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSubtype = false;
		}

		try
		{
			currentProtocol = creationEvent.getProtocol();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocol = false;
		}
		
		try
		{
			currentKit = creationEvent.getKit();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentKit = false;
		}
	
		try
		{
			currentTag = extract.getTag();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentTag = false;
		}

		try
		{
			if (parentType == Item.SAMPLE)
			{
				currentSample = (Sample)extract.getParent();
				if (currentSample != null) 
				{
					usedFromSample = creationEvent.getUsedQuantity(currentSample);
				}
			}
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSample = false;
		}
		try
		{
			currentBioWell = extract.getBioWell();
			lockedWell = extract.isLockedInWell();
			if (currentBioWell != null)
			{
				currentBioPlate = currentBioWell.getPlate();
			}
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentBioWell = false;
			readCurrentBioPlate = false;
		}
	
		// Query to retrieve pooled extracts
		if (parentType == Item.EXTRACT)
		{
			extractsQuery = creationEvent.getSources();
		}
	}
	
	// Default items 
	int activeProjectId = sc.getActiveProjectId();
	List<Protocol> defaultProtocols = null;
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);
		ItemSubtype protocolSubtype = currentSubtype == null ? null : currentSubtype.getRelatedSubtype(Item.PROTOCOL);
		if (protocolSubtype == null) protocolSubtype = ItemSubtype.getById(dc, SystemItems.getId(Protocol.EXTRACTION));
		defaultProtocols = activeProject.findDefaultItems(dc, protocolSubtype, false);
	}

	// Load recently used items
	List<Kit> recentKits = cc.getRecent(dc, Item.KIT, currentSubtype);
	List<Protocol> recentProtocols = cc.getRecent(dc, Item.PROTOCOL, currentSubtype);
	List<Sample> recentSamples = cc.getRecent(dc, Item.SAMPLE);
	List<BioPlate> recentBioPlates = cc.getRecent(dc, Item.BIOPLATE, currentSubtype);
	List<Tag> recentTags = cc.getRecent(dc, Item.TAG, currentSubtype);
	
	// Query to retrieve item types
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);
	subtypesQuery.include(Include.ALL);

	JSONObject jsonBioWell = null;
	if (currentBioWell != null)
	{
		jsonBioWell = new JSONObject();
		jsonBioWell.put("id", currentBioWell.getId());
		jsonBioWell.put("location", currentBioWell.getCoordinate());
	}

	JSONObject jsonExtracts = new JSONObject();
	jsonExtracts.put("itemType", "EXTRACT");
	if (extractsQuery != null)
	{
		extractsQuery.setIncludes(Include.ALL);
		extractsQuery.order(Orders.asc(Hql.property("name")));
		final BioMaterialEvent event = creationEvent;
		jsonExtracts.put("items", JsonUtil.toArray(extractsQuery.iterate(dc), new NameableConverter<Extract>()
		{
			protected void setMore(JSONObject json, Extract e)
			{
				Float usedQuantity = event == null ? null : event.getUsedQuantity(e);
				json.put("name", e.getName() + (usedQuantity == null ? " [-]" : " [" +  usedQuantity + " µg]"));
				json.put("value", usedQuantity);
			}
		}));
	}
	
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), extract);
	ExtensionsInvoker<TabAction> invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,linkitems-2.js,subtypes.js,~extracts.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="extract">
		<input type="hidden" name="cmd" value="UpdateItem">

		<div id="page-data" class="datacontainer"
			data-extraction-protocoltype-id="<%=SystemItems.getId(Protocol.EXTRACTION)%>"
			data-extraction-kittype-id="<%=SystemItems.getId(Kit.EXTRACTION) %>"
			data-extract-type="<%=Item.EXTRACT.getValue()%>"
			<%
			if (jsonBioWell != null)
			{
				%>
				data-biowell="<%=HTML.encodeTags(jsonBioWell.toJSONString()) %>"
				<%
			}
			%>
		></div>

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol" 
			position="bottom" remember="<%=extract != null%>" 
			extensions="<%=invoker%>">
		<t:tab id="info" title="Extract" helpid="extract.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" 
					data-auto-init="<%=extract == null ? "focus-select" : "focus" %>" type="text" name="name" 
					value="<%=HTML.encodeTags(name)%>" 
					maxlength="<%=Extract.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr >
				<th>Type</th>
				<td>
					<select name="subtype_id" id="subtype_id"
						<%=!readCurrentSubtype ? "disabled readonly class=\"disabled selectionlist\"" : "class=\"selectionlist\""%>>
					<%
					if (!readCurrentSubtype)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">-none-
						<%
						int currentSubtypeId = currentSubtype == null ? 0 : currentSubtype.getId();
						for (ItemSubtype subtype : subtypesQuery.list(dc))
						{
							int id = subtype.getId();
							if (id != currentSubtypeId && subtype.isRemoved()) continue;
							%>
							<option value="<%=id == currentSubtypeId && extract != null ? -id : id%>" 
								<%=id == currentSubtypeId ? "selected" : ""%>
								title="<%=HTML.encodeTags(subtype.getDescription()) %>"
								><%=HTML.encodeTags(subtype.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Tag</th>
				<td>
					<base:select 
						id="tag_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentTag%>"
						denied="<%=!readCurrentTag%>"
						recent="<%=recentTags%>"
						newitem="<%=extract == null%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>External ID</th>
				<td><input class="text" type="text" name="external_id" 
					value="<%=HTML.encodeTags(extract == null ? Values.getString(cc.getPropertyValue("externalId"), "") : extract.getExternalId())%>" 
					maxlength="<%=Extract.MAX_EXTERNAL_ID_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Original quantity</th>
				<td><input class="text" type="text" name="original_quantity" id="original_quantity" style="width: 15em;"
					value="<%=Values.formatNumber(extract == null ? Values.getFloat(cc.getPropertyValue("originalQuantity"), null): extract.getOriginalQuantity(), -1)%>"
					maxlength="10"> (µg)</td>
				<td></td>
			</tr>
			<tr>
				<th>Created</th>
				<td>
					<table>
					<tr>
					<td>
						<input class="text" style="width: 15em;" type="text" name="event_date" id="event_date"
							<%=lockEventProperties ? "disabled" : ""%>
							value="<%=HTML.encodeTags(dateFormatter.format(eventDate))%>" 
							 maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
					</td>
					<td>
						<base:calendar textarea="event_date" title="Created"
							disabled="<%=lockEventProperties%>"
						/>
					</td>
					</tr>
					</table>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Registered</th>
				<td><%=dateFormatter.format(creationEvent == null ? new Date() : creationEvent.getEntryDate())%></td>
				<td></td>
			</tr>
			<tr>
				<th>Protocol</th>
				<td>
					<base:select 
						id="protocol_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocol%>"
						denied="<%=!readCurrentProtocol%>"
						recent="<%=recentProtocols%>"
						defaultitems="<%=defaultProtocols%>"
						newitem="<%=extract == null%>"
						disabled="<%=lockEventProperties%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Kit</th>
				<td>
					<base:select 
						id="kit_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentKit%>"
						denied="<%=!readCurrentKit%>"
						recent="<%=recentKits%>"
						newitem="<%=extract == null%>"
						disabled="<%=lockEventProperties%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Bioplate</th>
				<td>
					<base:select 
						id="bioplate_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentBioPlate%>"
						denied="<%=!readCurrentBioPlate%>"
						recent="<%=recentBioPlates%>"
						newitem="<%=extract == null%>"
						disabled="<%=lockedWell%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th class="subprompt">- well</th>
				<td>
					<base:select 
						id="biowell_id"
						clazz="selectionlist"
						required="false"						
						current="<%=null %>"
						denied="<%=!readCurrentBioWell%>"
						newitem="<%=extract == null%>"
						disabled="<%=lockedWell%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(extract == null ? cc.getPropertyValue("description") : extract.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="parents" title="Parents" helpid="extract.parents">
			<table class="fullform input100">
			<tr>
				<th>Parent type</th>
				<td>
					<input type="radio" name="parentType" id="parentType.sample" 
						value="SAMPLE" <%=parentType != Item.EXTRACT ? "checked" : ""%>
						><label for="parentType.sample">Sample</label>
					<input type="radio" name="parentType" id="parentType.extract" 
						value="EXTRACT" <%=parentType == Item.EXTRACT ? "checked" : ""%>
						><label for="parentType.extract">Extract</label>
				</td>
			</tr>
			<tr>
				<th>Sample</th>
				<td>
					<base:select 
						id="sample_id"
						clazz="selectionlist"
						buttonstyle="width: 14em;"
						buttonicon="add.png"
						buttontitle="Select sample&hellip;"
						buttonclass="leftaligned basicbutton button"
						required="false"
						current="<%=currentSample%>"
						denied="<%=!readCurrentSample%>"
						recent="<%=recentSamples%>"
						selectrecent="false"
						newitem="<%=extract == null%>"
					/>
				</td>
			</tr>
			<tr>
				<th class="subprompt">used quantity</th>
				<td>
					<input class="text" style="width: 15em;" type="text" name="used_from_sample"
						id="used_from_sample" 
						value="<%=Values.formatNumber(usedFromSample, -1)%>"
						maxlength="10"> (µg)
				</td>
			</tr>
			<tr class="big">
				<th>Extracts</th>
				<td>
					<div class="selectionlist">
					<table>
					<tr>
					<td>
						<select name="extracts" id="extracts"
							class="auto-init"
							data-auto-init="link-container"
							data-initial-items="[<%=HTML.encodeTags(jsonExtracts.toJSONString()) %>]"
							data-initial-action="<%=extract == null ? 1 : 0 %>"
							size="15" multiple>
						</select>
					</td>
					<td>
					<td style="vertical-align: top;">
						<base:buttongroup vertical="true">
							<base:button 
								id="btnAddExtracts"
								subclass="leftaligned"
								style="width: 14em;"
								title="Add&nbsp;extracts&hellip;" 
								tooltip="Add extracts"
							/>
							<base:button 
								subclass="leftaligned auto-init"
								data-auto-init="remove-link"
								data-list-id="extracts"
								style="width: 14em;"
								title="Remove" 
								tooltip="Remove the selected extracts"
							/>
						</base:buttongroup>
					</td>
					</tr>
					</table>
					</div>
				</td>
			</tr>
			<tr>
				<th class="subprompt">used quantity</th>
				<td>
					<input class="text" style="width: 15em;" type="text" name="used_quantity" 
						id="used_quantity" value="" maxlength="10" > (µg)
				</td>
			</tr>					
			<tr class="dynamic">
				<th></th>
				<td></td>
			</tr>
			</table>
		</t:tab>

		<t:tab id="annotations" title="Annotations &amp; parameters" helpid="annotations.edit">
			<jsp:include page="../../common/annotations/annotate_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>
		
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
