/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2013 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var Messages = function()
{
	var messages = {};
	
	/**
		Initialize the page.
	*/
	messages.initPage = function()
	{
		var pageId = Doc.getPageId();		
		if (pageId == 'view-page')
		{
			var itemId = Data.get('page-data', 'item-id');
			var attributes = {'item-type': 'MESSAGE', 'item-id': itemId};
			
			Buttons.addClickHandler('btnUsingItems', Buttons.showUsingItems, attributes);
			Buttons.addClickHandler('btnDeletePermanently', Buttons.deleteItemPermanently, attributes);
			Events.addEventHandler('btnDeletePermanently', 'base-notify', messages.messageDeleted);
			Buttons.addClickHandler('close', App.closeWindow);
		}
		else if (pageId == 'list-page')
		{
			var attributes = {'item-type': 'MESSAGES'};
			var tableAttributes = {'table-id': 'messages'};
			Buttons.addClickHandler('btnMarkAsRead', messages.markAsRead, tableAttributes);
			Buttons.addClickHandler('btnDeleteItems', Buttons.deleteItems, tableAttributes);
			Buttons.addClickHandler('btnRestoreItems', Buttons.restoreItems, tableAttributes);
			Buttons.addClickHandler('btnColumns', Buttons.configureColumns, tableAttributes);
			Buttons.addClickHandler('btnExport', Buttons.runListPlugin, tableAttributes);
			Buttons.addClickHandler('btnImport', Buttons.runListPlugin, tableAttributes);
			Buttons.addClickHandler('btnRunPlugin', Buttons.runListPlugin, tableAttributes);
			
			Buttons.addClickHandler('close', App.closeWindow);
			Buttons.addClickHandler('btnOk', Buttons.returnSelected);
		}
	}

	messages.messageDeleted = function(event)
	{
		window.opener.Items.list('MESSAGE'); 
		window.close();
	}
	
	messages.markAsRead = function() 
	{
		Table.submitSelected('messages', 'MarkAsRead');
	}

	return messages;
}();

Doc.onLoad(Messages.initPage);
